
#include "a4c.ime.h"
#include "fox-logo.xpm"

/********************************************/
void Quit(a4cALL *ALL)
{
  XDestroyWindow(ALL->MAIN.disp,ALL->MAIN.win);
  XCloseDisplay(ALL->MAIN.disp);
  iomeFreeConfiguration(&ALL->CONF.SYS);
  iomeFreeConfiguration(&ALL->CONF.CONF);
  iomeFreeConfiguration(&ALL->CONF.MODULES);
  die("All For Chinese IME happily off duty!!!");
}

void SetDefault(a4cALL *ALL)
{
  char * buff;

  ALL->MAIN.fontsize_name[0] = iomeWhichItem(&ALL->CONF.CONF,"size.half");
  ALL->MAIN.fontsize_name[1] = iomeWhichItem(&ALL->CONF.CONF,"size.full");
  ALL->MAIN.method_size      = 1;
  ALL->MAIN.filter_size      = 1;
  ALL->MAIN.METHOD_ENGLISH   = iomeWhichItem(&ALL->CONF.CONF,"method.english");
  ALL->MAIN.FILTER_NEUTRAL   = iomeWhichItem(&ALL->CONF.CONF,"charset.neutral");
  ALL->MAIN.neutral_charset  = "neutral";
  ALL->MAIN.current_charset  = ALL->MAIN.neutral_charset;
  /* Setting up Audio */
  ALL->MAIN.AUDIO_DEVICE     = iomeWhichItem(&ALL->CONF.CONF,"audio");
  ALL->MAIN.WARNING_FILE     = iomeWhichItem(&ALL->CONF.CONF,"message.warning");

  buff = iomeWhichItem(&ALL->CONF.CONF,"autoraise");
  ALL->MAIN.autoraise        = (strcasecmp(buff,"enable")==0);
  buff = iomeWhichItem(&ALL->CONF.CONF,"autohide");
  ALL->MAIN.autohide         = (strcasecmp(buff,"enable")==0);
  ALL->MAIN.autostate        = 0;
}

int SetSound(a4cALL *ALL)
{
  int okay = 1;
  /* Test Drive */
  if (ALL->MAIN.AUDIO_DEVICE==NULL||ALL->MAIN.WARNING_FILE==NULL) okay=0;
  if (okay&&!a4cPlayWAVE(ALL->MAIN.AUDIO_DEVICE,ALL->MAIN.WARNING_FILE)) okay=0;
  if (!okay) {
    ALL->MAIN.AUDIO_DEVICE = NULL;
    ALL->MAIN.WARNING_FILE = NULL;
    a4cMakeNoise(&ALL->MAIN);
  }
}

void ShowIME(a4cALL *ALL)
{
  if (ALL->MAIN.autoraise) {
    if (ALL->MAIN.current_method>0 ||
        ALL->MAIN.current_filter>0 ||
        ALL->MAIN.fontsize>0) {

//      if (!ALL->MAIN.autostate) {
        XMapWindow(ALL->MAIN.disp,ALL->MAIN.win);
        XRaiseWindow(ALL->MAIN.disp,ALL->MAIN.win);
//      }

      ALL->MAIN.autostate = 1;
    } else {
      if (ALL->MAIN.autohide) {
        XUnmapWindow(ALL->MAIN.disp,ALL->MAIN.win);
      }
      ALL->MAIN.autostate = 0;
    }
  }
}

void SwitchFontSize(a4cALL *ALL)
{
  ALL->MAIN.fontsize^=1;
  ALL->MAIN.FontSize.message = ALL->MAIN.fontsize_name[ALL->MAIN.fontsize];
  a4cDraw(&ALL->MAIN);
  a4cMakeNoise(&ALL->MAIN);
  ShowIME(ALL);
}

void SwitchOutputFilter(a4cALL *ALL)
{
  ALL->MAIN.translating = 0;
  if (ALL->MAIN.current_filter==0) {
    ALL->MAIN.Charset.message = ALL->MAIN.FILTER_NEUTRAL;
  } else {
    ALL->MAIN.FILTER_NOW = ALL->MAIN.FILTER[ALL->MAIN.current_filter];
    /* Call for PREPARE ? */
    ALL->MAIN.Charset.message = ALL->MAIN.FILTER_NOW->RECORD.FilterName;
  }
  a4cDraw(&ALL->MAIN);
  a4cMakeNoise(&ALL->MAIN);
  ShowIME(ALL);
}

void NextOutputFilter(a4cALL * ALL)
{
  /* Switch Output Filter Modules */
  ALL->MAIN.current_filter++;  
  ALL->MAIN.current_filter%=ALL->MAIN.filter_size;
  SwitchOutputFilter(ALL);
}

void SwitchMethod(a4cALL *ALL)
{
  ALL->MAIN.translating = 0;
  if (ALL->MAIN.current_method==0) {
    ALL->MAIN.current_charset  = ALL->MAIN.neutral_charset;
    ALL->MAIN.Method.message   = ALL->MAIN.METHOD_ENGLISH;
    ALL->MAIN.KeyArea.message[0]  = 0;
    ALL->MAIN.ListArea.message[0] = 0;
  } else {
    ALL->MAIN.METHOD_NOW      = ALL->MAIN.METHOD[ALL->MAIN.current_method];
    ALL->MAIN.METHOD_NOW->PREPARE(&ALL->MAIN.METHOD_NOW->RECORD);
    ALL->MAIN.Method.message   = ALL->MAIN.METHOD_NOW->RECORD.MethodName;
    ALL->MAIN.KeyArea.message[0] = 0;
    ALL->MAIN.ListArea.message[0] = 0;
    ALL->MAIN.current_charset  = ALL->MAIN.METHOD_NOW->RECORD.Encoding;
  }
  a4cDraw(&ALL->MAIN);
  a4cMakeNoise(&ALL->MAIN);
  ShowIME(ALL);
}

void DoAccel(int accel,a4cALL * ALL)
{
  int n;
  int id;
  char * buf;

  if (ALL->MAIN.ACCEL[accel].method<0) {
    buf = strdup(ALL->MAIN.ACCEL[accel].command);
    SendString(&ALL->MAIN,buf);
    free(buf);
  } else {
    buf = ALL->MAIN.ACCEL[accel].command;
    /* Search for Input Method */
    for (n=1,id=0;n<ALL->MAIN.method_size;n++) 
      if (strcmp(buf,ALL->MAIN.METHOD[n]->RECORD.MethodName)==0) { id=n; break; }
    if (id>0) {
      /* Switch Input Method */
      ALL->MAIN.current_method = id;
      SwitchMethod(ALL);
      SendZeroOut(&ALL->MAIN);
      return;
    } else {
      /* Search for Filter */
      for (n=1,id=0;n<ALL->MAIN.filter_size;n++) 
        if (strcmp(buf,ALL->MAIN.FILTER[n]->RECORD.FilterName)==0) { id=n; break; }
      if (id>0) {
        /* Switch Filter */
        ALL->MAIN.current_filter = id;
        SwitchOutputFilter(ALL);
        SendZeroOut(&ALL->MAIN);
        return;
      }
    }
    SendReject(&ALL->MAIN);
  }
}

void NextInputMethod(a4cALL *ALL)
{
  ALL->MAIN.current_method++;
  ALL->MAIN.current_method%=ALL->MAIN.method_size;
  SwitchMethod(ALL);
}

void DrawMETHOD(a4cMAIN *MAIN)
{
  if (MAIN->translating>1) {
    strcpy(MAIN->KeyArea.message,MAIN->FILTER_NOW->RECORD.KeyArea);
    strcpy(MAIN->ListArea.message,MAIN->FILTER_NOW->RECORD.ListArea);
  } else {
    strcpy(MAIN->KeyArea.message,MAIN->METHOD_NOW->RECORD.KeyArea);
    strcpy(MAIN->ListArea.message,MAIN->METHOD_NOW->RECORD.ListArea);
  }
}

void SendOutRespond(a4cALL *ALL,int R,int ch)
{
  a4cMAIN * MAIN = &ALL->MAIN;
  switch (R) {
    case IME_RT_REJECT:
      /* Send Full Size Font */
      if (MAIN->fontsize!=0&&ch>=' '&&ch<=0x7e) {
        SendFullSizeFont(ALL,ch);
        break;
      }
      SendReject(MAIN);
      DrawMETHOD(MAIN);
    break;
    case IME_RT_BLOCKOUT: 
      SendZeroOut(MAIN);
      DrawMETHOD(MAIN);
    break;
    case IME_RT_SEND:
      if (MAIN->translating>1&&strlen(MAIN->FILTER_NOW->RECORD.Value)>0) {
        UnifyCharset(MAIN,MAIN->FILTER_NOW->RECORD.Value);
        SendString(MAIN,MAIN->FILTER_NOW->RECORD.Value);
        MAIN->FILTER_NOW->RECORD.Value[0]=0;
        strcpy(MAIN->KeyArea.message,MAIN->FILTER_NOW->RECORD.KeyArea);
        strcpy(MAIN->ListArea.message,MAIN->FILTER_NOW->RECORD.ListArea);
      } else
      if (strlen(MAIN->METHOD_NOW->RECORD.Value)>0) {
        UnifyCharset(MAIN,MAIN->METHOD_NOW->RECORD.Value);
        SendString(MAIN,MAIN->METHOD_NOW->RECORD.Value);
        MAIN->METHOD_NOW->RECORD.Value[0]=0;
        DrawMETHOD(MAIN);
      } else {
        SendZeroOut(MAIN);
        DrawMETHOD(MAIN);
      }
    break;
  }

  UnifyCharset(MAIN,MAIN->KeyArea.message);
  UnifyCharset(MAIN,MAIN->ListArea.message);

}

void GoForMethod(a4cALL *ALL,KeySym ch,int state)
{
  a4cMAIN *MAIN=&ALL->MAIN;
  int c = xKeySymToIOME(ch);
  int s = xKeyStateToIOME(state);
  int R;

  if (ALL->MAIN.translating>1) {
    R = MAIN->FILTER_NOW->FEEDKEY(&MAIN->FILTER_NOW->RECORD,c,s);
    if (R==IME_RT_REJECT) {
      MAIN->translating = 0;
      R = MAIN->METHOD_NOW->FEEDKEY(&MAIN->METHOD_NOW->RECORD,c,s);
    }
  } else R = MAIN->METHOD_NOW->FEEDKEY(&MAIN->METHOD_NOW->RECORD,c,s);
  SendOutRespond(ALL,R&IME_RT_MASK,ch);
  a4cDraw(MAIN);
  if ((R&IME_RT_CRY)==IME_RT_CRY) a4cMakeNoise(&ALL->MAIN);
}

void SwitchInputBetweenEnglish(a4cALL *ALL)
{
  if (ALL->MAIN.current_method==0) { /* which means it's now English */
    if (ALL->MAIN.last_method==0) {
      ALL->MAIN.current_method++;
      ALL->MAIN.current_method%=ALL->MAIN.method_size;
    } else {
      /* Last Time We have something, restore it */
      ALL->MAIN.current_method = ALL->MAIN.last_method;
    }
  } else {
    /* Switch To English */
    ALL->MAIN.last_method    = ALL->MAIN.current_method;
    ALL->MAIN.current_method = 0;
  }
  /* Deal With Method Switch */
  SwitchMethod(ALL);
}

void GetInputKey(a4cALL * ALL,KeySym ch,int state)
{
  int respond   = 0;
  int shift     = state&ShiftMask;
  int ctrl      = state&ControlMask;
  int alt       = state&(Mod1Mask|Mod5Mask);
  int ctrl_alt  = state&(ControlMask|Mod1Mask|Mod5Mask);
  int accel;
  
  /* Test Keys */
  ALL->MAIN.replied = 0;
  if (ctrl&&(ch==' '||ch==0)) {
    /* Control+Space = SwitchInputBetweenEnglish */
    SwitchInputBetweenEnglish(ALL);
    SendZeroOut(&ALL->MAIN);
    return;
  } else
  if (shift&&ch==' ') {
    /* Shift+Space = SwitchFontSize */
    SwitchFontSize(ALL);
    SendZeroOut(&ALL->MAIN);
    return;
  } else
  if (ctrl&&(ch=='~'||ch=='`')) {
    NextOutputFilter(ALL);
    SendZeroOut(&ALL->MAIN);
    return;
  } else
  if (ctrl&&alt) {
    /* Control+Alt */
    accel = a4cLookupAccelerator(IME_KF_CONTROL|IME_KF_ALT,ch,&ALL->MAIN);
    if (accel>=0) DoAccel(accel,ALL);
             else SendZeroOut(&ALL->MAIN);
    return;
  } else
  if (alt&&shift) {
    /* lookup key */
    accel = a4cLookupAccelerator(IME_KF_ALT|IME_KF_SHIFT,ch,&ALL->MAIN);
    if (accel>=0) {
      DoAccel(accel,ALL);
      return;
    }
  } else  
  if (ALL->MAIN.current_method!=0&& /* which means not in english mode */
      !(state&(ControlMask|Mod1Mask|Mod5Mask))&&
      (ch!=XK_Control_L)) {
    /* manipulate input methods */
    GoForMethod(ALL,ch,state);
    return;
  } else
  if (((ch==XK_Control_L) && (state&ShiftMask))||
      ((ch==XK_Shift_L) && (state&ControlMask))) {
    /* Ctrl+Shift = Next Input Method */
    NextInputMethod(ALL);
    SendZeroOut(&ALL->MAIN);
    return;
  }
  if (!ctrl_alt&&((ALL->MAIN.current_method==0)||(!respond))) {
    /* Send Full Size Font */
    if (ALL->MAIN.fontsize!=0&&ch>=' '&&ch<=0x7e) {
      SendFullSizeFont(ALL,ch);
      return;
    }
  }
  if (!ALL->MAIN.replied) {
    if (respond) SendZeroOut(&ALL->MAIN);
            else SendReject(&ALL->MAIN);
  }
}

void a4cClientMessage(XEvent event,a4cALL *ALL)
{
  if (event.xclient.message_type == ALL->MAIN.XCIN) {
    XClientMessageEvent * xev = (XClientMessageEvent*)&event;
    unsigned char * buf = (unsigned char *)&xev->data.l[0];

    ALL->MAIN.CLI_WIN = xev->window;
    if (xev->format == 32) {
      GetInputKey(ALL,*(int*)buf,*((int*)&buf[4]));
    } else
    if (xev->format==8 &&
        buf[0]==0xff&&
        buf[1]==0xff&&
        buf[2]==0xff) {
      if (buf[3]==CLI_FOCUS_IN) {
        ALL->MAIN.LastWIN = xev->window;
        ShowIME(ALL);
      } else {
        /* Hide A4C IME */
        ShowIME(ALL);
      }
    } else
      report("Client Message Error!");
  } else
  if (event.xclient.format == 32 &&
      event.xclient.data.l[0] == ALL->MAIN.WM_DEL_WINDOW) Quit(ALL);
  else
    report("I don't know this client message, %x!",event.xclient.format);
}

void a4cPropertyNotify(XEvent event,a4cALL *ALL)
{
  XPropertyEvent *xev = (XPropertyEvent *)&event;
  Atom RealMan;
  int  RealFormat;
  unsigned long nitems, morebytes;
  int *cmd,c;

  if (xev->state==PropertyDelete||xev->window==ALL->MAIN.win) return;
  if (XGetWindowProperty(
        ALL->MAIN.disp,
        xev->window,
        ALL->MAIN.XCIN,
        0,1,True,AnyPropertyType,
        &RealMan,
        &RealFormat,
        &nitems,
        &morebytes,
        (unsigned char **)&cmd
      ) != Success) report("Property Error!");
  if (nitems==0) return;
  c = *cmd;
  XFree(cmd);
  report("Load KEYWORD");
}

void a4cExpose(XEvent event,a4cALL *ALL)
{
  a4cDraw(&ALL->MAIN);
}

void GoForKeyArea(a4cALL *ALL,int x,int y)
{
  a4cMAIN *MAIN=&ALL->MAIN;
  int R;

  if (MAIN->current_method==0) return;
  if (MAIN->METHOD_NOW==NULL) return;
  R = MAIN->METHOD_NOW->KEYAREA(&MAIN->METHOD_NOW->RECORD,x,y);
  if ((R&IME_RT_MASK)==0) return;
  SendOutRespond(ALL,R&IME_RT_MASK,0);
  if ((R&IME_RT_CRY)==IME_RT_CRY) a4cMakeNoise(&ALL->MAIN);
  a4cDraw(MAIN);
}

void GoForListArea(a4cALL *ALL,int x,int y)
{
  a4cMAIN *MAIN=&ALL->MAIN;
  int R;

  if (MAIN->current_method==0) return;
  if (MAIN->METHOD_NOW==NULL) return;
  R = MAIN->METHOD_NOW->LISTAREA(&MAIN->METHOD_NOW->RECORD,x,y);
  if ((R&IME_RT_MASK)==0) return;
  SendOutRespond(ALL,R&IME_RT_MASK,0);
  if ((R&IME_RT_CRY)==IME_RT_CRY) a4cMakeNoise(&ALL->MAIN);
  a4cDraw(MAIN);
}

void a4cButtonPress(XEvent event,a4cALL *ALL)
{
  XButtonEvent * xev = (XButtonEvent*)&event;
  int where;
  switch (xev->button) {
    case Button1:
      where = a4cWhere(&ALL->MAIN,xev->x,xev->y);
      if (where==A4C_NOWHERE) break;
      switch (where) {
        case A4C_METHOD:   /* Switch Method or Next Method */
          NextInputMethod(ALL);
        break;
        case A4C_CHARSET:  /* Switch Output Filter */
          NextOutputFilter(ALL);
        break;
        case A4C_FONTSIZE: /* Switch Font Size */
          SwitchFontSize(ALL);
        break;
        case A4C_KEYAREA:  /* Hit in the keyarea */
          /* As far as I knew, this should be nothing to do */
          GoForKeyArea(ALL,xev->x-ALL->MAIN.KeyArea.Text.x1,xev->y-ALL->MAIN.KeyArea.Text.y1);
        break;
        case A4C_LISTAREA: /* Hit in the ListArea */
          GoForListArea(ALL,xev->x-ALL->MAIN.ListArea.Text.x1,xev->y-ALL->MAIN.ListArea.Text.y1);
        break;
      }
    break;
    case Button2: /* middle button */
      /* Open Configurator, anywhere in this window */
    break;
    case Button3: /* right button */
      /* Move window, anywhere in this window */
    break;
  }
}

void a4cVisibilityNotify(XEvent event,a4cALL *ALL)
{
  XVisibilityEvent * ev = (XVisibilityEvent*)&event;
  if (ev->window == ALL->MAIN.win &&
      (ev->state == VisibilityPartiallyObscured||
       ev->state == VisibilityFullyObscured)) {
    /* report("Visibility"); */
  }
}

void a4cDestroyNotify(XEvent event,a4cALL *ALL)
{
  Quit(ALL);
}

void main(int argc,char **argv)
{
  a4cEventHandler MyHand =  {
    a4cKeyPress,
    a4cClientMessage,
    a4cPropertyNotify,
    a4cMappingNotify,
    a4cExpose,
    a4cExpose,
    a4cButtonPress,
    a4cVisibilityNotify,
    a4cDestroyNotify,
    a4cUnknownEvent
  };
  a4cALL ALL;
  int r;

  memset(&ALL,0,sizeof(ALL));

  r = iomeDefaultLoader(&ALL.CONF);
  if (r!=1) die("Load Error %d",r);

  a4cWarmUp(argc,argv,&ALL.MAIN,&ALL.CONF,fox_logo_xpm);
  SetDefault(&ALL);
  a4cLoadModules(&ALL.MAIN,&ALL.CONF.MODULES,&ALL.CONF.CONF);
  a4cLoadAccelerators(iomeWhichItem(&ALL.CONF.CONF,"accelerator"),&ALL.MAIN);
  SetSound(&ALL);

  a4cXWAIT(&MyHand,&ALL);
}
